<template>
    <div class='checkout'>
    <v-card class="pa-2 mx-auto lista-sem-formatacao" outlined tile width="300" justify="center">
        <div class='nada-selecionado'>
            <h1>Carrinho</h1>

            <v-card class="mx-auto" max-width="344">
                <v-list-item three-line>
                    <v-list-item-content>
                        <v-list-item-subtitle class='itens-carrinho' v-for="(item,i) in carrinhoPedido" :key="item.i">
                            x{{item.quantidade}} {{getNomeProduto(item.produto_id)}}
                            <!-- <v-btn class="float-right" >x</v-btn> -->
                            <v-chip @click="removerItemCarrinho(i)" class="ma-2 chips" color="red" text-color="white">remover
                            </v-chip>
                        </v-list-item-subtitle>
                    </v-list-item-content>
                </v-list-item>
            </v-card>

            <br>
            <h2>Total a pagar</h2> <div style="margin: -27px 0 0 150px;color: red;" v-show="valorDesconto > 0">Desconto já incluso no valor total R$ {{valorDesconto}}</div>
            <v-card class="mx-auto" max-width="344">
                <v-card-title>R$ {{valorTotal}}</v-card-title> 
            </v-card>

            <br>
            <h2>Forma de Pagamento</h2>
            <v-card class="mx-auto forma_pagamento" max-width="344">
                <v-select v-model="formaPagamentoEscolhida" :items="formasPagamento" :rules="(formaPagamentoEscolhida != undefined) ? [true] : [false]"
                    dense ></v-select>
            </v-card>

            

            <v-row justify="center" no-gutters width="344px">
                <v-col max-width="150px">
                    <h2>Valor pago</h2>
                    <v-card class="mx-auto valor_pago" max-width="150">
                        <v-text-field @focus="$event.target.select()" v-model="valorPago" min="0" value="10" prefix="R$" type="number" :rules="(valorPago > 0) ? [true] : [false]"></v-text-field>
                    </v-card>
                </v-col>
                <v-col max-width="150px">
                    <h2>Troco</h2>
                    <v-card class="mx-auto valor_troco" max-width="150">
                        <v-card-title>R$ {{valorTroco}}</v-card-title>
                    </v-card>
                </v-col>
            </v-row>
            <br>
            <v-btn @click="confirmarPedidoDialog = true" v-show="carrinhoPedido != undefined && carrinhoPedido != null && carrinhoPedido.length > 0">
                Confirmar Pedido
            </v-btn>
        </div>
    </v-card>

        <!-- CONFIRMAR PEDIDO -->
        <v-dialog v-model="confirmarPedidoDialog" max-width="390">
            <v-card>
                <v-card-title class="headline">Deseja confirmar esse pedido?</v-card-title>

                <v-card-text>
                    {{pedidoFinal}}
                </v-card-text>

                <v-card-text>
                    <p v-for="(car,index) in carrinhoPedido" :key="index">
                        {{car.quantidade}} - {{getNomeProduto(car.produto_id)}}
                    </p>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>

                    <v-btn color="red darken-1" text @click="confirmarPedidoDialog = false">
                        Cancelar
                    </v-btn>

                    <v-btn color="green darken-1" text @click="confirmaPedidoDialog()">
                        Confirmar
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

    </div>
</template>

<script>
    export default {
        name: 'Checkout',
        inject: ['removerItemCarrinho','confirmarPedido','getNomeCaixa','calculaTroco'],
        props: [
            'carrinho',
            'tiposProdutos',
            'produtos',
            'valorTotal',
            'formasPagamento',
            'valorTroco',
            'valorDesconto',
        ],
        data() {
            return {
                carrinhoPedido: [],
                listaTipoProduto: [],
                listaProdutos: [],
                formaPagamentoEscolhida: {},
                confirmarPedidoDialog: false,
                valorPago: 0,
                pedidoFinal: {
                    'status_id': 1, //OK
                    'forma_pagamento_id': 0, //OK
                    'dinheiro_pago': 0, //OK
                    'dinheiro_troco': 0, //OK
                    'motivo_cancelado': '-',
                    'nome_cliente': '',
                    'telefone': '',
                    'nome_caixa': '', //OK
                },
            }
        },
        watch: {
            carrinho: function () {
                console.log("Checkout watch carrinho");
                this.carrinhoPedido = this.carrinho;
                if (this.carrinho.lenght == 0)
                    this.formaPagamentoEscolhida = undefined;
            },
            tiposProdutos: function () {
                console.log("Checkout watch tiposProdutos");
                this.listaTipoProduto = this.tiposProdutos;
            },
            produtos: function () {
                console.log("Checkout watch produtos");
                this.listaProdutos = this.produtos;
            },
            formaPagamentoEscolhida: function () {
                console.log("Checkout watch formaPagamentoEscolhida", this.formaPagamentoEscolhida);
                this.pedidoFinal.forma_pagamento_id = this.formaPagamentoEscolhida;
            },
            valorPago: function () {
                console.log("Checkout watch valorPago", this.valorPago);
                this.calculaTroco(this.valorTotal, this.valorPago);
                this.pedidoFinal.dinheiro_pago = this.valorPago;
            },
            valorTroco: function () {
                console.log("Checkout watch valorTroco", this.valorTroco);
                this.pedidoFinal.dinheiro_troco = this.valorTroco;
            },
            valorTotal: function () {
                if (this.valorTotal == 0) {
                    this.valorPago = 0;
                    this.formaPagamentoEscolhida = undefined;
                }
            },
        },
        created: async function () {
            console.log("Checkout created");
        },
        mounted: async function () {
            console.log("Checkout mounted");

            this.pedidoFinal.nome_caixa = this.getNomeCaixa();
        },
        methods: {
            // removerItem: function (i) {
            //     console.log("Checkout removerItem", i);
            // },
            getNomeProduto: function (produto_id) {
                console.log("Checkout getNomeProduto", produto_id);

                return this.$parent.$parent.getNomeProduto(produto_id);
            },
            confirmaPedidoDialog: function () {
                console.log("Checkout confirmaPedidoDialog");
                this.confirmarPedidoDialog = false;
                this.confirmarPedido(this.pedidoFinal);
            }
        }
    }
</script>

<style lang="scss">
    .valor_pago {
        padding: 0 10px;
        font-size: 1.25rem;
    }

    .valor_troco {
        margin-top: 5px;
    }

    .forma_pagamento {
        padding: 8px 12px 0;
    }

    .float-right {
        float: right;
    }

    .itens-carrinho {
        padding: 5px;
    }

    .chips {
        font-size: 10px !important;
    }
</style>